--- cli.c.orig	2004-07-04 03:03:44.000000000 -0400
+++ cli.c	2004-07-04 03:02:47.000000000 -0400
@@ -25,6 +25,7 @@
 #include <stdio.h>
 #include <signal.h>
 #include <string.h>
+#include <errno.h>
 /* For rl_filename_completion */
 #include "editline/readline/readline.h"
 /* For module directory */
@@ -37,12 +38,16 @@
 	
 void ast_cli(int fd, char *fmt, ...)
 {
+	int res;
 	char *stuff;
 	va_list ap;
 	va_start(ap, fmt);
 	vasprintf(&stuff, fmt, ap);
 	va_end(ap);
-	write(fd, stuff, strlen(stuff));
+	res = write(fd, stuff, strlen(stuff));
+	while (res == -1 && errno == EAGAIN) 
+		res = write(fd, stuff, strlen(stuff));
+
 	free(stuff);
 }
 
